#!/bin/bash

# expected formats:
#  http://user:password@proxy.url.com:9090/path
#  http://user:password@proxy.url.com/path
#  http://proxy.url.com/path
#  user:password@proxy.url.com/path
#  proxy.url.com/path

password_path=$1
config_path=$2
is_transparent=$3

if [[ -z "$HTTPS_PROXY" ]]; then
	proxy_url_from_env=$HTTP_PROXY
else
	proxy_url_from_env=$HTTPS_PROXY
fi

# if container user credentials
if [[ "$proxy_url_from_env" != ${proxy_url_from_env#*@} ]] && [[ $is_transparent == "false" ]]; then
	url=${proxy_url_from_env#*://}
	proto=${proxy_url_from_env%://*}

	# no scheme provided
	if [[ "$proto" == "$proxy_url_from_env" ]]; then
		proxy_url=${url#*@}
	else
		proxy_url=$proto://${url#*@}
	fi

	userpass=${url%@*}
	username=${userpass%:*}
	password=${userpass#*:}
	echo $password > $password_path
else
	proxy_url=$proxy_url_from_env
fi

cat <<-EOF > $config_path
global:
  http_config:
    proxy_url: $proxy_url
EOF

if [ ! -f $password_path ] || [[ -z $username ]]; then
	exit 0
fi

cat <<-EOF >> $config_path
    basic_auth:
      username: $username
      password_file: $password_path
EOF
